#!/usr/local/bin/python
#
# adzapper
# Copyright 1999 Adam Feuer
# Adam Feuer <adamf@pobox.com>
#
# This file is part of adzapper.
#
# adzapper is free software; you can redistribute it and/or modify
# it under the terms of the Zope Public License 1.0 as published by
# Digital Creations.
#
# adzapper is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# Zope Public License for more details.
#
# You should have received a copy of the Zope Public License 1.0
# along with adzapper; see the file COPYING.
#
#  "This product includes software developed by Digital Creations
#  for use in the Z Object Publishing Environment
#  (http://www.zope.org/)."
#
#
# this provides a method used to override the asyncore.poll method--
# to allow us to catch SIGHUP signals during an I/O event
#
RCS_ID =  '$Id: asyncore_fixes.py,v 1.1 1999/09/14 18:34:40 adamf Exp $'

import asyncore
import select

def a_poll (timeout=0.0):
	if asyncore.socket_map:
		r = []; w = []; e = []
		for s in asyncore.socket_map.keys():
			if s.readable():
				r.append (s)
			if s.writable():
				w.append (s)

                # SIGHUP will interrupt the select() system call--
                # make sure we restart it if that happens.
                selectErrNum = 4
                while (selectErrNum == 4):
                                selectErrNum = 0
                                try:
                                                (r,w,e) = select.select (r,w,e, timeout)
                                except select.error, val:
                                                selectErrNum = val[0]
        

		for x in r:
			try:
				x.handle_read_event()
			except:
				x.handle_error()
		for x in w:
			try:
				x.handle_write_event()
			except:
				x.handle_error()
